"""
Saving MANIN objects to database
"""

#*****************************************************************************
#       Copyright (C) 2004 William Stein <was@math.harvard.edu>
#
#  Distributed under the terms of the GNU General Public License (GPL)
#
#    This code is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    General Public License for more details.
#
#  The full text of the GPL is available at:
#
#                  http://www.gnu.org/licenses/
#*****************************************************************************

PATH="/home/was/hecke2/v5/db/"

import cPickle,pickle
import os

USE_DB=False

def path():
    if not os.path.exists(PATH):
        os.mkdir(PATH)

# todo: problem:
#   m = ms(37)
#   a = m[0]
#   db.save(a)
#  causes major problems when reloaded, since ms(37) isn't saved!


def save(x, filename):
    """
    save(x, filename):
    
    Saves x to a file.  Pretty much the only constraint on x is that
    it have no circular references (it must be Python pickle-able).
    This uses the pickle module, so data you save is *guaranteed*
    to be readable by future versions of Python.

    INPUT:
       x -- almost arbitrary object
       filename -- a string

    OUTPUT:
       Creates a file named filename, from which the object x
       can be reconstructed. 
    """
    
    o=open(filename,"w")
    cPickle.dump(x,o,1)
    o.close()


def load(filename):
    """
    load(filename):
    
    Loads an object from filename and returns it.  

    INPUT:
       filename -- a string that defines a valid file.  If the
          file doesn't exist then an IOError exception is raised.

    OUTPUT:
       An almost arbitrary object.
    """

    o = open(filename,"r")
    return cPickle.load(o)


def save_db(x):
    """Save x to the database.  x must define a filename method."""
    path()
    fn = PATH + x.filename()
    save(x,fn)
    os.system("bzip2 -f %s"%fn)


def load_db(x):
    """Load x from the database.  x must define a filename method."""
    fn = PATH + x.filename()
    if os.path.exists(fn + ".bz2"):
        print "Loading %s from %s."%(x,x.filename())
        os.system("bunzip2 -f -k %s"%(fn + ".bz2"))
        o=open(fn,"r")
        x = cPickle.load(o)
        os.system("rm %s"%fn)
        return x
    else:
        return None
